/*
 * @author Venkat Subramaniam
 * DuraSoft, Inc.
 * http://www.durasoftcorp.com/download
 */

using System;

namespace SystexDifferencesOverriding
{
	class User
	{
		public static void playWithBase(Base obj)
		{
			obj.f1();
			obj.f2();
			obj.f3();
		}

		public static void playWithDerived(Derived obj)
		{
			obj.f1();
			obj.f2();
			obj.f3();
		}

		[STAThread]
		static void Main(string[] args)
		{
			Derived obj = new Derived();
			Console.WriteLine("Since we are using the same object in both calls,");
			Console.WriteLine("a well written program should produce the same");
			Console.WriteLine("results in both calls below");
			Console.WriteLine("---------------");
			playWithBase(obj);
			Console.WriteLine("---------------");
			playWithDerived(obj);
			Console.WriteLine("---------------");
			Console.WriteLine("**** Please read the comments in Derived.cs ****");
		}
	}
}
